"""
    ELEMENTS API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 2
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from elements_sdk.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from elements_sdk.exceptions import ApiAttributeError


def lazy_import():
    from elements_sdk.model.backend import Backend
    from elements_sdk.model.interface import Interface
    from elements_sdk.model.storage_node_status import StorageNodeStatus
    globals()['Backend'] = Backend
    globals()['Interface'] = Interface
    globals()['StorageNodeStatus'] = StorageNodeStatus


class StorageNode(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('task_queues',): {
            'MEDIA': "media",
            'DEFAULT': "default",
        },
        ('ipmi',): {
            '1': 1,
            '2': 2,
            '3': 3,
        },
        ('type',): {
            '1': 1,
            '2': 2,
            '3': 3,
        },
    }

    validations = {
        ('name',): {
            'max_length': 255,
            'min_length': 1,
        },
        ('address',): {
            'max_length': 255,
            'min_length': 1,
        },
        ('ipmi_address',): {
            'max_length': 255,
        },
        ('ipmi_username',): {
            'max_length': 255,
            'min_length': 1,
        },
        ('ipmi_password',): {
            'max_length': 255,
            'min_length': 1,
        },
        ('discovery_address_override',): {
            'max_length': 255,
        },
        ('permission_mask',): {
            'min_length': 1,
        },
        ('address_override',): {
            'max_length': 255,
        },
        ('onefs_host',): {
            'max_length': 255,
        },
        ('onefs_username',): {
            'max_length': 255,
        },
        ('onefs_password',): {
            'max_length': 255,
        },
        ('onefs_zone',): {
            'max_length': 255,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (int,),  # noqa: E501
            'backend': (Backend,),  # noqa: E501
            'interfaces': ([Interface],),  # noqa: E501
            'is_log_aggregator': (bool,),  # noqa: E501
            'status': (StorageNodeStatus,),  # noqa: E501
            'task_queues': ([str],),  # noqa: E501
            'unique_id': (str, none_type,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'address': (str,),  # noqa: E501
            'ipmi': (int,),  # noqa: E501
            'ipmi_address': (str, none_type,),  # noqa: E501
            'ipmi_username': (str,),  # noqa: E501
            'ipmi_password': (str,),  # noqa: E501
            'proxy_queue': (bool,),  # noqa: E501
            'email_queue': (bool,),  # noqa: E501
            'solr_indexer_enabled': (bool,),  # noqa: E501
            'discovery_enabled': (bool,),  # noqa: E501
            'discovery_address_override': (str, none_type,),  # noqa: E501
            'ntp_enabled': (bool,),  # noqa: E501
            'type': (int,),  # noqa: E501
            'allow_root_login': (bool,),  # noqa: E501
            'permission_mask': (str,),  # noqa: E501
            'address_override': (str, none_type,),  # noqa: E501
            'auto_scan_interfaces': (bool,),  # noqa: E501
            'onefs_host': (str, none_type,),  # noqa: E501
            'onefs_username': (str, none_type,),  # noqa: E501
            'onefs_password': (str, none_type,),  # noqa: E501
            'onefs_zone': (str, none_type,),  # noqa: E501
            'volume_queues': ([int],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'backend': 'backend',  # noqa: E501
        'interfaces': 'interfaces',  # noqa: E501
        'is_log_aggregator': 'is_log_aggregator',  # noqa: E501
        'status': 'status',  # noqa: E501
        'task_queues': 'task_queues',  # noqa: E501
        'unique_id': 'unique_id',  # noqa: E501
        'name': 'name',  # noqa: E501
        'address': 'address',  # noqa: E501
        'ipmi': 'ipmi',  # noqa: E501
        'ipmi_address': 'ipmi_address',  # noqa: E501
        'ipmi_username': 'ipmi_username',  # noqa: E501
        'ipmi_password': 'ipmi_password',  # noqa: E501
        'proxy_queue': 'proxy_queue',  # noqa: E501
        'email_queue': 'email_queue',  # noqa: E501
        'solr_indexer_enabled': 'solr_indexer_enabled',  # noqa: E501
        'discovery_enabled': 'discovery_enabled',  # noqa: E501
        'discovery_address_override': 'discovery_address_override',  # noqa: E501
        'ntp_enabled': 'ntp_enabled',  # noqa: E501
        'type': 'type',  # noqa: E501
        'allow_root_login': 'allow_root_login',  # noqa: E501
        'permission_mask': 'permission_mask',  # noqa: E501
        'address_override': 'address_override',  # noqa: E501
        'auto_scan_interfaces': 'auto_scan_interfaces',  # noqa: E501
        'onefs_host': 'onefs_host',  # noqa: E501
        'onefs_username': 'onefs_username',  # noqa: E501
        'onefs_password': 'onefs_password',  # noqa: E501
        'onefs_zone': 'onefs_zone',  # noqa: E501
        'volume_queues': 'volume_queues',  # noqa: E501
    }

    read_only_vars = {
        'interfaces',  # noqa: E501
        'is_log_aggregator',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, backend, interfaces, is_log_aggregator, *args, **xkwargs):  # noqa: E501
        """StorageNode - a model defined in OpenAPI

        Args:
            id (int):
            backend (Backend):
            interfaces ([Interface]):
            is_log_aggregator (bool):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            status (StorageNodeStatus): [optional]  # noqa: E501
            task_queues ([str]): [optional]  # noqa: E501
            unique_id (str, none_type): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            address (str): For communication between nodes only. [optional]  # noqa: E501
            ipmi (int): [optional]  # noqa: E501
            ipmi_address (str, none_type): [optional]  # noqa: E501
            ipmi_username (str): [optional]  # noqa: E501
            ipmi_password (str): [optional]  # noqa: E501
            proxy_queue (bool): [optional]  # noqa: E501
            email_queue (bool): [optional]  # noqa: E501
            solr_indexer_enabled (bool): [optional]  # noqa: E501
            discovery_enabled (bool): [optional]  # noqa: E501
            discovery_address_override (str, none_type): [optional]  # noqa: E501
            ntp_enabled (bool): [optional]  # noqa: E501
            type (int): [optional]  # noqa: E501
            allow_root_login (bool): [optional]  # noqa: E501
            permission_mask (str): Comma-separated list of user permissions allowed on this node. [optional]  # noqa: E501
            address_override (str, none_type): Enforces mounting from a specific address/hostname instead of the available interfaces. [optional]  # noqa: E501
            auto_scan_interfaces (bool): [optional]  # noqa: E501
            onefs_host (str, none_type): [optional]  # noqa: E501
            onefs_username (str, none_type): [optional]  # noqa: E501
            onefs_password (str, none_type): [optional]  # noqa: E501
            onefs_zone (str, none_type): [optional]  # noqa: E501
            volume_queues ([int]): Run volume-specific tasks for selected volumes.. [optional]  # noqa: E501
        """

        _check_type = xkwargs.pop('_check_type', True)
        _spec_property_naming = xkwargs.pop('_spec_property_naming', False)
        _path_to_item = xkwargs.pop('_path_to_item', ())
        _configuration = xkwargs.pop('_configuration', None)
        _visited_composed_classes = xkwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)


        self.id = id
        self.backend = backend
        self.interfaces = interfaces
        self.is_log_aggregator = is_log_aggregator
        for var_name, var_value in xkwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self


    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, backend, *args, **xkwargs):  # noqa: E501
        """StorageNode - a model defined in OpenAPI

        Args:
            id (int):
            backend (Backend):
        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            status (StorageNodeStatus): [optional]  # noqa: E501
            task_queues ([str]): [optional]  # noqa: E501
            unique_id (str, none_type): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            address (str): For communication between nodes only. [optional]  # noqa: E501
            ipmi (int): [optional]  # noqa: E501
            ipmi_address (str, none_type): [optional]  # noqa: E501
            ipmi_username (str): [optional]  # noqa: E501
            ipmi_password (str): [optional]  # noqa: E501
            proxy_queue (bool): [optional]  # noqa: E501
            email_queue (bool): [optional]  # noqa: E501
            solr_indexer_enabled (bool): [optional]  # noqa: E501
            discovery_enabled (bool): [optional]  # noqa: E501
            discovery_address_override (str, none_type): [optional]  # noqa: E501
            ntp_enabled (bool): [optional]  # noqa: E501
            type (int): [optional]  # noqa: E501
            allow_root_login (bool): [optional]  # noqa: E501
            permission_mask (str): Comma-separated list of user permissions allowed on this node. [optional]  # noqa: E501
            address_override (str, none_type): Enforces mounting from a specific address/hostname instead of the available interfaces. [optional]  # noqa: E501
            auto_scan_interfaces (bool): [optional]  # noqa: E501
            onefs_host (str, none_type): [optional]  # noqa: E501
            onefs_username (str, none_type): [optional]  # noqa: E501
            onefs_password (str, none_type): [optional]  # noqa: E501
            onefs_zone (str, none_type): [optional]  # noqa: E501
            volume_queues ([int]): Run volume-specific tasks for selected volumes.. [optional]  # noqa: E501
        """

        _check_type = xkwargs.pop('_check_type', True)
        _spec_property_naming = xkwargs.pop('_spec_property_naming', False)
        _path_to_item = xkwargs.pop('_path_to_item', ())
        _configuration = xkwargs.pop('_configuration', None)
        _visited_composed_classes = xkwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)


        self.id = id
        self.backend = backend
        for var_name, var_value in xkwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

